﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default3.aspx.cs" Inherits="Default3" %>

<%@ Register assembly="Infragistics35.Web.v10.1, Version=10.1.20101.1011, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" namespace="Infragistics.Web.UI.GridControls" tagprefix="ig" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    
    <script language="javascript">
        // flag used when the row edit template is closed to indicate if you should add new row
        var isAddingNew = false;
        
        function showEditRowTemplateOnAddNew() {
            // set the flag to show that this is adding new
            isAddingNew = true;
            var grid = $find("WebDataGrid1");
            var behaviors = grid.get_behaviors();
            
            //take the row editing template
            var roweditingtemplate = behaviors.getBehaviorByName("RowEditingTemplate");
            
            //get the row adding behavior 
            var rowaddingbehavior = grid.get_behaviors().get_editingCore().get_behaviors().get_rowAdding();
            roweditingtemplate.enterEditMode(rowaddingbehavior._row);
        }
        
        function initializeGrid(sender, args) {
            var grid = $find("<%=WebDataGrid1.ClientID %>");
            var rowaddingbehavior = grid.get_behaviors().get_editingCore().get_behaviors().get_rowAdding();
            
            // add onclick event for the selector cell of the "add new" row
            $addHandler(rowaddingbehavior._rowElement.cells[0], "click", showEditRowTemplateOnAddNew);
         
        }
        function templateClosed(sender, args) {
            // if new row is added and the OK button is clicked
            if (isAddingNew && (event.srcElement.id == "WebDataGrid1_ctl00_buttonOK")) {
                var grid = $find("WebDataGrid1");
                var rows = grid.get_rows();
                var rowaddingbehavior = grid.get_behaviors().get_editingCore().get_behaviors().get_rowAdding();
                var rowValuesArr = constructArray(rowaddingbehavior._row);
                rows.add(rowValuesArr);
            }
           
            //reset the flag awlays
            isAddingNew = false;
        }
        function constructArray(row) {
            var arr = new Array();
            for (var i = 0; i < row._cells.length; i++) {

                arr[i] = row._cells[i].get_value();
            } 
            return arr; 
               
        }
       
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
    
    </div>
    <ig:WebDataGrid ID="WebDataGrid1" DataKeyFields="ProductID" runat="server" AutoGenerateColumns="False" 
        DataSourceID="SqlDataSource1" Height="350px" Width="400px" 
        >
        <Columns>
            <ig:BoundDataField DataFieldName="ProductID" Key="ProductID">
                <header text="ProductID" />
            </ig:BoundDataField>
            <ig:BoundDataField DataFieldName="ProductName" Key="ProductName">
                <header text="ProductName" />
            </ig:BoundDataField>
            <ig:BoundDataField DataFieldName="UnitPrice" Key="UnitPrice">
                <header text="UnitPrice" />
            </ig:BoundDataField>
        </Columns>
        <Behaviors>
            <ig:EditingCore>
                <Behaviors>
                    <ig:RowEditingTemplate CancelButton="buttonCancel" OKButton="buttonOK">
                        <ClientBindings>
                            <ig:RowEditingClientBinding ColumnKey="ProductID" ControlID="control_ProductID" 
                                GetValueJavaScript="$get({ClientID}).value" 
                                SetValueJavaScript="$get({ClientID}).value={value}" />
                            <ig:RowEditingClientBinding ColumnKey="ProductName" 
                                ControlID="control_ProductName" GetValueJavaScript="$get({ClientID}).value" 
                                SetValueJavaScript="$get({ClientID}).value={value}" />
                            <ig:RowEditingClientBinding ColumnKey="UnitPrice" ControlID="control_UnitPrice" 
                                GetValueJavaScript="$get({ClientID}).value" 
                                SetValueJavaScript="$get({ClientID}).value={value}" />
                        </ClientBindings>
                        <RowEditingClientEvents TemplateClosed="templateClosed" />
                        <Template>
                            <div style="background-color:white;border:1px solid black;">
                                ProductID:
                                <asp:TextBox ID="control_ProductID" runat="server"></asp:TextBox>
                                <br />
                                ProductName:
                                <asp:TextBox ID="control_ProductName" runat="server"></asp:TextBox>
                                <br />
                                UnitPrice:
                                <asp:TextBox ID="control_UnitPrice" runat="server"></asp:TextBox>
                                <br />
                                <asp:Button ID="buttonOK" runat="server" OnClientClick="return" Text="OK" 
                                    UseSubmitBehavior="False" />
                                <asp:Button ID="buttonCancel" runat="server" CausesValidation="False" 
                                    OnClientClick="return" Text="Cancel" UseSubmitBehavior="False" />
                            </div>
                        </Template>
                    </ig:RowEditingTemplate>
                    <ig:RowAdding >
                        <ColumnSettings>
                            <ig:RowAddingColumnSetting ColumnKey="ProductID" ReadOnly="True" />
                            <ig:RowAddingColumnSetting ColumnKey="ProductName" ReadOnly="True" />
                            <ig:RowAddingColumnSetting ColumnKey="UnitPrice" ReadOnly="True" />
                        </ColumnSettings>
                    </ig:RowAdding>
                </Behaviors>
            </ig:EditingCore>
            <ig:RowSelectors>
            </ig:RowSelectors>
        </Behaviors>
        <ClientEvents Initialize="initializeGrid" />
    </ig:WebDataGrid>
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    <asp:SqlDataSource ID="SqlDataSource1" runat="server" 
        ConnectionString="<%$ ConnectionStrings:NorthwindConnectionString %>" 
        
        SelectCommand="SELECT [ProductID], [ProductName], [UnitPrice] FROM [Products]" 
        DeleteCommand="DELETE FROM [Products] WHERE [ProductID] = @ProductID" 
        InsertCommand="INSERT INTO [Products] ([ProductName], [UnitPrice]) VALUES (@ProductName, @UnitPrice)" 
        UpdateCommand="UPDATE [Products] SET [ProductName] = @ProductName, [UnitPrice] = @UnitPrice WHERE [ProductID] = @ProductID">
        <DeleteParameters>
            <asp:Parameter Name="ProductID" Type="Int32" />
        </DeleteParameters>
        <UpdateParameters>
            <asp:Parameter Name="ProductName" Type="String" />
            <asp:Parameter Name="UnitPrice" Type="Decimal" />
            <asp:Parameter Name="ProductID" Type="Int32" />
        </UpdateParameters>
        <InsertParameters>
            <asp:Parameter Name="ProductName" Type="String" />
            <asp:Parameter Name="UnitPrice" Type="Decimal" />
        </InsertParameters>
    </asp:SqlDataSource>
    </form>
</body>
</html>
